////////////////////////////////
//
// Prototype Input Selector 
// Elkaid
//
// May 2002 
//
///////////////////////////////

#include	<pic1684.h>

unsigned char OldEncoderPosition = 0;
unsigned char NewEncoderPosition = 0;

unsigned char WarmupDelayPassed = 0;

void TubeWarmup(void);
void CheckEncoderPosition(void);

unsigned int i=0, j=0;

void main(void)
{
	OPTION = 0x81;
	PORTA = 0x00;			// Encoder connected to RA0, RA1
	PORTB = 0x00;			// Outputs connected on RB0 - RB3
	TRISA = 0x03;			// RA0, RA1 are encoder inputs
	TRISB = 0x00;			// RB0-RB3 are relay outputs

	TubeWarmup();
		
	while(1)	
	{
		CheckEncoderPosition();	
	}		
}

void TubeWarmup(void)
{
	for(j=0;j<0x20;j++)
	{
		PORTB = 0x10;  // Blink red
		for(i=0;i<0xFFFF;i++);
		
		
		PORTB = 0x20;  // Blink green
		for(i=0;i<0xFFFF;i++);		
	}

	PORTB = 0x10;  // Light up the green led
}

void CheckEncoderPosition(void)
{
	switch(PORTA & 0x03)
	{
		case 0x00:	PORTB = 0x11;
					break;

		case 0x01: 	PORTB = 0x12;
					break;

		case 0x02:	PORTB = 0x14;
					break;

		case 0x03: 	PORTB = 0x18;
					break;
	}
}
